#!/bin/sh

TFTPSERVER=10.10.10.12
FILE=exgine.cfg

# parses URL for HOST=[IP ADDRESS] for GET CGI 
TFTPSERVER=$REQUEST_URI
TFTPSERVER=`echo $TFTPSERVER | sed -e 's/.*osupload.sh\?*//'`
TFTPSERVER=`echo $TFTPSERVER | sed -e 's/.*HOST\=\(.*\)/\1/'`

echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>Configuration File Upload</TITLE><BODY><H2>Configuration Upload Results:</H2>";
echo "<BR>Ensure that the TFTP server is started on " $TFTPSERVER
echo "<BR>Please wait until update has completed...<P><PRE>";
cd /mnt/flash

echo "Uploading $FILE from TFTP server ..."
cd /tmp/
tftp -g -r $FILE $TFTPSERVER
if [ -e $FILE ]; then
	SIZE=`ls -s $FILE`;
	for S in $SIZE
	do
		if [ $S = "0" ]; then
			echo "$FILE did not transfer (0 bytes) ... aborting."
			exit
		fi
	done
	
	cat /proc/flash_write_enable
	mount -o remount,rw /mnt/flash
	if [ -e /mnt/flash/exgine.cfg ] ; then 
	    cp /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
	fi
	cp -f exgine.cfg /mnt/flash/exgine.cfg
	mount -o remount,ro /mnt/flash
	cat /proc/flash_write_disable

	echo "Configuration file upload completed."
else
	echo "ERROR: Configuration file transfer failed."
fi
echo "</PRE><BODY></HTML>";
