#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>Edit Configuration File</TITLE><BODY>";
cd /mnt/flash

# any CGI posted data will cause an update
read data_in

#
# Display current config file in form
#
if [ "X$data_in" = "X" ]; then
	
	echo "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/editcfg.sh\">"
	echo "Setting: <SELECT NAME=\"name\">"
	sed -e "s/#.*//" -e "s/^\(.*\):.*$/\<OPTION VALUE=\"\1\"\> \1/" /mnt/flash/exgine.cfg
	echo "<OPTION>"
	echo "</SELECT>"
	echo "Value: <INPUT TYPE=text NAME=\"value\">"
	echo "<INPUT TYPE=submit VALUE=\"Change Setting\">"
	echo "</FORM>"
	echo "<PRE>"
	echo "<H2>Current Configuration File:</H2><FORM>"
	cat exgine.cfg	
	echo "</PRE>"
	echo "</BODY></HTML>";
	exit;
fi

#
# Perform the update
#
data_in=`httpd -d "$data_in"`;
name=`echo $data_in | sed -e 's/.*name=\([^\&]*\)\&\?.*/\1/'`
value=`echo $data_in | sed -e 's/.*value=\([^\&]*\)\&\?.*/\1/'`

if [ "X$name" = "X" ]; then
	echo "No configuration setting was specified ... no changes have been updated."
	exit;
fi

if [ "X$value" = "X" ]; then
	echo "No configurtaion value was specified ... no changes have been updated."
	exit;
fi

sed -e	"s/\($name:[ \t]*\)[^ \t\#]*\(.*$\)/\1$value\2/" /mnt/flash/exgine.cfg > /tmp/exgine.cfg

cat /proc/flash_write_enable > /dev/null
mount -o remount,rw /mnt/flash

if [ -e /mnt/flash/exgine.cfg ] ; then 
    cp -f /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
fi
cp -f /tmp/exgine.cfg /mnt/flash/exgine.cfg

mount -o remount,ro /mnt/flash
cat /proc/flash_write_disable > /dev/null

echo "Setting $name has been updated to $value <BR>"
echo "Please restart exgine for the changes to take effect."



